import { TerraformBackend, TerraformElement } from 'cdktf';
import { Construct } from 'constructs';
import { TerraformInjectorCommon, TerraformInjectorElementContainerClass, TerraformInjectorConfigureCallbackType, TerraformInjectorConfigureCallbackAsyncType, TerraformInjectorElementContainer, TerraformInjectorElementContainerAsync, TerraformInjectorElementClassType, TerraformInjectorElementClassWithoutIdType, TerraformLazyElement, TerraformLazyElementAsync, TerraformInjectorNestedConfigureCallbackType, TerraformInjectorNestedConfigureCallbackAsyncType } from '../../../module';
export declare class TerraformInjectorClass implements TerraformInjectorCommon {
    scope: Construct;
    useAsync: boolean;
    caller: string;
    description?: string | undefined;
    elementMap: Map<string, TerraformInjectorElementContainerClass<any, any, any>>;
    _defaultConfigure?: (id: string, className: string, description?: string) => {
        [x: string]: any;
    };
    onNewElementInjectedCallbackArray: ((element: TerraformElement) => void)[];
    get defaultConfigure(): ((id: string, className: string, description?: string | undefined) => {
        [x: string]: any;
    }) | undefined;
    constructor(scope: Construct, useAsync: boolean, caller: string, description?: string | undefined);
    toString(): string;
    backend<TerraformBackendType extends TerraformBackend, PropsType, SharedType = undefined>(terraformBackendClass: TerraformInjectorElementClassWithoutIdType<TerraformBackendType, PropsType>, configure: TerraformInjectorConfigureCallbackType<PropsType, SharedType> | TerraformInjectorConfigureCallbackAsyncType<PropsType, SharedType>, description?: string): TerraformInjectorElementContainerAsync<TerraformBackendType, SharedType>;
    provide<TerraformElementType extends TerraformElement, ConfigType, SharedType = undefined>(terraformElementClass: TerraformInjectorElementClassType<TerraformElementType, ConfigType>, id: string, configure: TerraformInjectorConfigureCallbackType<ConfigType, SharedType> | TerraformInjectorConfigureCallbackAsyncType<ConfigType, SharedType>, useDefaultConfig?: boolean, description?: string): TerraformInjectorElementContainerAsync<TerraformElementType, SharedType>;
    provideLazily<NestedTerraformElementType extends TerraformElement, NestedConfigType, NestedSharedType = undefined, SharedType = undefined>(nestedTerraformElementClass: TerraformInjectorElementClassType<NestedTerraformElementType, NestedConfigType>, id: string, configure: TerraformInjectorNestedConfigureCallbackAsyncType<NestedConfigType, NestedSharedType, SharedType> | TerraformInjectorNestedConfigureCallbackType<NestedConfigType, NestedSharedType, SharedType>, useDefaultConfig?: boolean, description?: string): TerraformInjectorElementContainerAsync<TerraformLazyElementAsync<NestedTerraformElementType, NestedConfigType, NestedSharedType>, SharedType> | TerraformInjectorElementContainer<TerraformLazyElement<NestedTerraformElementType, NestedConfigType, NestedSharedType>, SharedType>;
    setDefaultConfigure(defaultConfigure: (id: string, className: string, description?: string) => {
        [x: string]: any;
    }): TerraformInjectorClass;
    onNewElementInjected(onNewElementInjectedCallback: (element: TerraformElement) => void): TerraformInjectorClass;
    inject(): void | Promise<void>;
    get isInjected(): boolean;
}
