import { TerraformElement, TerraformOutputConfig } from 'cdktf';
import { Construct } from 'constructs';
import { TerraformInjectorElementClassType, TerraformInjectorElementClassWithoutIdType, TerraformInjectorConfigureCallbackAsyncType, TerraformInjectorConfigureCallbackType, TerraformInjectorElementContainerUninitializedError, TerraformInjectorElementContainerAsync, TerraformInjectorClass } from '../../../module';
export declare class TerraformInjectorElementContainerClass<TerraformElementType extends TerraformElement, ConfigType, SharedType> implements TerraformInjectorElementContainerAsync<TerraformElementType, SharedType> {
    scope: Construct;
    terraformElementClass: TerraformInjectorElementClassType<TerraformElementType, ConfigType> | TerraformInjectorElementClassWithoutIdType<TerraformElementType, ConfigType>;
    id: string;
    configure: TerraformInjectorConfigureCallbackType<ConfigType, SharedType> | TerraformInjectorConfigureCallbackAsyncType<ConfigType, SharedType>;
    injector: TerraformInjectorClass;
    caller: string;
    useDefaultConfig: boolean;
    description?: string | undefined;
    name: string;
    dependencies: Set<TerraformInjectorElementContainerClass<any, any, any>>;
    dependents: Set<TerraformInjectorElementContainerClass<any, any, any>>;
    isInitialized: boolean;
    terraformElementContainerNonInitializedError: TerraformInjectorElementContainerUninitializedError;
    afterInitElementCallbackContainerArray: {
        isCalled: boolean;
        callback: (element: TerraformElementType, shared: SharedType) => void | Promise<void>;
    }[];
    afterDependenciesInjectedCallbackContainerArray: {
        isCalled: boolean;
        callback: (element: TerraformElementType, shared: SharedType) => void | Promise<void>;
    }[];
    _shared: SharedType;
    _element: TerraformElementType;
    get shared(): SharedType;
    get element(): TerraformElementType;
    constructor(scope: Construct, terraformElementClass: TerraformInjectorElementClassType<TerraformElementType, ConfigType> | TerraformInjectorElementClassWithoutIdType<TerraformElementType, ConfigType>, id: string, configure: TerraformInjectorConfigureCallbackType<ConfigType, SharedType> | TerraformInjectorConfigureCallbackAsyncType<ConfigType, SharedType>, injector: TerraformInjectorClass, caller: string, useDefaultConfig: boolean, description?: string | undefined);
    toString(): string;
    afterInitElement(afterInitCallback: (element: TerraformElementType, shared: SharedType) => void | Promise<void>): this;
    afterDependenciesInjected(afterDependenciesInjectedCallback: (element: TerraformElementType, shared: SharedType) => void | Promise<void>): this;
    addOutput(outputId: string | ((elementId: string) => string), outputConfig: (element: TerraformElementType, shared: SharedType) => TerraformOutputConfig): this;
    inject(upperInjectors: Array<TerraformInjectorClass>): TerraformInjectorElementContainerClass<any, any, any> | void;
    injectAsync(upperInjectors: Array<TerraformInjectorClass>): Promise<TerraformInjectorElementContainerClass<any, any, any> | void>;
    private initialize;
}
